/*
 * This file is a part of the SteamWar software.
 *
 * Copyright (C) 2021  SteamWar.de-Serverteam
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.bausystem.region.flags.flagvalues;

import de.steamwar.bausystem.region.Color;
import de.steamwar.bausystem.region.flags.Flag;
import lombok.AllArgsConstructor;
import lombok.Getter;

@Getter
@AllArgsConstructor
public enum ColorMode implements Flag.Value<ColorMode> {
    WHITE("FLAG_COLOR_WHITE", Color.WHITE),
    ORANGE("FLAG_COLOR_ORANGE", Color.ORANGE),
    MAGENTA("FLAG_COLOR_MAGENTA", Color.MAGENTA),
    LIGHT_BLUE("FLAG_COLOR_LIGHT_BLUE", Color.LIGHT_BLUE),
    YELLOW("FLAG_COLOR_YELLOW", Color.YELLOW),
    LIME("FLAG_COLOR_LIME", Color.LIME),
    PINK("FLAG_COLOR_PINK", Color.PINK),
    GRAY("FLAG_COLOR_GRAY", Color.GRAY),
    LIGHT_GRAY("FLAG_COLOR_LIGHT_GRAY", Color.LIGHT_GRAY),
    CYAN("FLAG_COLOR_CYAN", Color.CYAN),
    PURPLE("FLAG_COLOR_PURPLE", Color.PURPLE),
    BLUE("FLAG_COLOR_BLUE", Color.BLUE),
    BROWN("FLAG_COLOR_BROWN", Color.BROWN),
    GREEN("FLAG_COLOR_GREEN", Color.GREEN),
    RED("FLAG_COLOR_RED", Color.RED),
    BLACK("FLAG_COLOR_BLACK", Color.BLACK);

    private static ColorMode[] values;
    private final String chatValue;
    private final Color color;

    @Override
    public ColorMode[] getValues() {
        if (ColorMode.values == null) {
            ColorMode.values = ColorMode.values(); //NOSONAR
        }
        return ColorMode.values;
    }

    @Override
    public ColorMode getValue() {
        return this;
    }

    @Override
    public ColorMode getValueOf(final String name) {
        try {
            return ColorMode.valueOf(name.toUpperCase());
        } catch (IllegalArgumentException e) {
            return ColorMode.YELLOW;
        }
    }
}
